> For the complete documentation index, see [llms.txt](https://docs.talordata.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.talordata.com/serp-api/integration/sdk-integration/how-to-integrate-talordata-with-llamaindex.md).

# How to Integrate TalorData with LlamaIndex

Connect the TalorData SERP API to LlamaIndex, enabling your agents to perform real-time web search, image search, news search, and obtain structured search results. TalorData supports coverage across 195 countries/regions worldwide and is suitable for AI Agents, SEO tools, market research, and search-driven applications.

### Get TalorData API Token

* Log in to your [TalorData ](https://dashboard.talordata.com/)[Dashboard](https://dashboard.talordata.com/).
* Go to [SERP API - API Token](https://dashboard.talordata.com/scraping/serp-api/api-token). If you have not yet generated an API Token, generate a new one.

### Installation

Install the required package:

```
python -m pip install llama-index-tools-talordata-serp
```

### Usage Example

The following example demonstrates how to use TalorData tools with LlamaIndex.

```
llm = OpenAI(model="gpt-4o", api_key="your-api-key")
​
talordata_tool = talordataToolSpec(api_key="your-api-key", zone="unlocker")
​
tool_list = talordata_tool.to_tool_list()
​
for tool in tool_list:
    tool.original_description = tool.metadata.description
    tool.metadata.description = "talordata web scraping tool"
​
agent = OpenAIAgent.from_tools(tools=tool_list, llm=llm)
​
query = (
    "Find and summarize the latest news about AI from major tech news sites"
)
tool_descriptions = "\n\n".join(
    [
        f"Tool Name: {tool.metadata.name}\nTool Description: {tool.original_description}"
        for tool in tool_list
    ]
)
​
query_with_descriptions = f"{tool_descriptions}\n\nQuery: {query}"
​
response = agent.chat(query_with_descriptions)
print(response)
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.talordata.com/serp-api/integration/sdk-integration/how-to-integrate-talordata-with-llamaindex.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
